#
# $Header: /usr/home/cake/palm/src/plsync/lib/RCS/dbmdb.rb,v 1.1 2000/02/14 15:15:13 cake Exp cake $

# DBM, Marshal W[gy DataBase NX
#
# create_desc= Ȃ
#
#  id,attr,category,data1,data2......,updateflag

require "dbm"
#require "marshal"
require "PalmInterpreter"
require "Database"

class DbmDB
  include CSV_Database

  def db_file_path
    return "./db/"
  end

  def initialize(dbname="",create_desc="",type_desc=[])
    @create_desc = create_desc
    @dbname = dbname           
    @type_desc = type_desc

   #for update (new record)
    @newrec = []
  end
  
 public  
  def connect
    @dbm = DBM.open( db_file_path + @dbname )
  end

  def close
    if commit>0 then
    end
    @dbm.close if @dbm
    @dbm = nil
  end

  def update(id,attr,cat,content_array)
    update_record(id,attr,cat,content_array,DBFlagSynced)
  end

  def archive(id,attr,cat,content_array)
    update_record(id,attr,cat,content_array,DBFlagPalmDeleted)
  end
  
  def update_record(id,attr,cat,content_array,flag)
    @newrec << [ id, attr, cat, content_array, flag ]
  end

  def discardUpdate
    @newrec.clear
  end

  def commit
    @newrec.each do |r|
      k = r[0].to_s
      @dbm[ k ] = Marshal.dump( r )
    end

    r = @newrec.size
    discardUpdate
    return r
  end
  
  def delete(id)
    @dbm.delete( id.to_s )
    rec = @newrec.assoc( id )
    if rec then
      @newrec.delete( rec )
    end
  end
  
  def deleteAll
    @dbm.clear
    @newrec.clear
  end
  
  def each
    @dbm.each_value do | v |
      id, attr, cat, content_array, flag = Marshal.load( v )  # d
      yield flag, id, attr, cat, content_array
    end
  end
end
